pro anb_prog_code, image, par, init, inp_img_t, this_iter, tot_iter
  
; Comparison with given binary model
  if par.comparison eq 1B then begin
     ap_phot_cent_comp_1it, image, init.star, init.nb_ph_star, par.bin_separation, par.bin_pa,    $
                            par.d_detect, par.tresh_detect, par.aper_phot, par.centr_box_size,    $
                            inp_img_t.resolution, flag,                                           $
                            Mag_diff_int,                                                         $
                            sep_rel,                                                              $
                            pa_rel,                                                               $
                            sep_abs,                                                              $
                            pa_abs,                                                               $
                            xc,                                                                   $
                            yc,                                                                   $
                            delta_M,                                                              $
                            par.verbosity
                               ; non detection of main component, companion or both.
     if flag eq 0B then begin 
        init.Mag_diff_int[this_iter-1,*] = !values.f_nan ; residuals (original - detected) 
                                ; difference of magnitude
        init.sep_all_rel[this_iter-1]    = !values.f_nan ; relative separation (original - detected)
        init.pa_all_rel[this_iter-1]     = !values.f_nan ; relative PA (original - detected)
        init.sep_all[this_iter-1]        = !values.f_nan ; absolute separation (detected)  
        init.pa_all[this_iter-1]         = !values.f_nan ; absolute PA (detected)  
        init.xc[*,this_iter-1]           = !values.f_nan ; X centroids (main and companion)  
        init.yc[*,this_iter-1]           = !values.f_nan ; Y centroids (main and companion)  
        init.delta_M[*,this_iter-1,*]    = !values.f_nan ; main and companion magnitude residuals
     endif else begin    
        init.Mag_diff_int[this_iter-1,*] = Mag_diff_int         
        init.sep_all_rel[this_iter-1]    = sep_rel          
        init.pa_all_rel[this_iter-1]     = pa_rel           
        init.sep_all[this_iter-1]        = sep_abs              
        init.pa_all[this_iter-1]         = pa_abs               
        init.xc[*,this_iter-1]           = xc                   
        init.yc[*,this_iter-1]           = yc                   
        init.delta_M[*,this_iter-1,*]    = delta_M 	
        if par.verbosity then begin
           print, ''
           print, 'Detected Primary   [x,y]           =', xc[0], yc[0]
           print, 'Detected Secondary [x,y]           =', xc[1], yc[1]
           print, 'Detected separation [mas]          =', sep_abs*1e3
           print, 'Detected position angle [deg]      =', pa_abs
           print, 'Detected difference of magnitude :'
           for i=0, (size(par.aper_phot))[1]-1 do begin
              print, '                     [diam '+string(par.aper_phot[i], '(f3.1)')+'] =', $
                     (init.star[1].info[2] - init.star[0].info[2])- Mag_diff_int[i]
           endfor
           print, '================================================================================'
        endif
     endelse
     if (this_iter mod tot_iter EQ 0) then begin ;--- display line of results ---
        print, "#################TEST#####################"
        print, '-------------------------------------------------------------------'
        print, 'ANB:'
        print, ''								
        print, '================================================================================'
        print, '           COMPARATIVE PHOTOMETRIC AND ASTROMETRIC BINARY ANALYSIS              '
        print, '================================================================================'
        print, ''								
        print, 'Centroid box size [pixels]                  = ', par.centr_box_size			
        print, 'Set of aperture diameters [pixels]          = ', par.aper_phot				
        print, ''
        print, 'Last iteration results :'
        print, 'Detected Primary   [x,y]                    =', xc[0], yc[0]
        print, 'Detected Secondary [x,y]                    =', xc[1], yc[1]
        print, ''
        print, 'Original separation [mas]                   =', par.bin_separation*1e3
        print, 'Detected separation [mas]                   =', sep_abs*1e3
        print, '(Original - detected) separation [mas]      =', sep_rel*1e3
        print, ''
        print, 'Original position angle [deg]               =', par.bin_pa
        print, 'Detected position angle [deg]               =', pa_abs
        print, '(Original - detected) position angle [deg]  =', pa_rel
        print, ''
        print, 'Original difference of magnitude            =', (init.star[1].info[2] - init.star[0].info[2])
        print, '(Original - detected) difference of magnitude :'
        for i=0, (size(par.aper_phot))[1]-1 do begin
           print, '                     [diam '+string(par.aper_phot[i], '(f3.1)')+'] =', Mag_diff_int[i]
        endfor
        print, '================================================================================'
        print, ''
                                ;binary data filename (.sav)
        sav_file = par.cvparam.filename
                                ;Save binary data
        result_bin	= {		 			        $
                          star                 : init.star,            $
                          ap_phot_d            : par.aper_phot,        $
                          box_size             : par.centr_box_size,   $
                          Mag_diff_int         : init.Mag_diff_int,    $
                          sep_all_rel          : init.sep_all_rel,     $
                          pa_all_rel           : init.pa_all_rel,      $
                          sep_all              : init.sep_all,         $
                          pa_all               : init.pa_all,          $
                          xc                   : init.xc,              $
                          yc                   : init.yc,              $
                          delta_M 	        : init.delta_M,         $
                          nb_ph_star           : init.nb_ph_star,      $
                          sep                  : par.bin_separation,   $
                          pa                   : par.bin_pa,           $
                          d_detect             : par.d_detect,         $
                          tresh_detect         : par.tresh_detect,     $
                          pix_size             : inp_img_t.resolution  }
        save, result_bin, filename = sav_file  
                                ;Produce file .ps of parameters covergence ----------------------------
        enable   = [par.deltaM_cvplot.enable, par.separation_cvplot.enable, $
                    par.PA_cvplot.enable, par.Main_mag_cvplot.enable,       $
                    par.Comp_mag_cvplot.enable]              
        filename = [par.deltaM_cvplot.filename, par.separation_cvplot.filename, $
                    par.PA_cvplot.filename, par.Main_mag_cvplot.filename,       $
                    par.Comp_mag_cvplot.filename]              
                                ;first aperture phot. diam. to plot (0 begining)
        first = 0
                                ;pre_defined line type
        lsty         = [3,2,1,0,4,5,6]
        thickk       = [4,4,4,4,4,4,4]
        astr_lsty    = 0
        astr_tck     = 4
        make_graph_bin_comp, sav_file, par.aper_phot, first, inp_img_t.resolution, $
                             lsty, thickk, astr_lsty, astr_tck, enable, filename   
     endif
  endif else begin 
                                ; absolute binary parameters (excluded single magnitude)
;ap_phot_cent, inp_img_t.image, 2, par.d_detect, par.tresh_detect, par.aper_phot, par.centr_box_size, $
;                      inp_img_t.resolution , tot_iter   
     ap_phot_cent_1it, image, par.d_detect, par.tresh_detect, par.aper_phot,  $
                       par.centr_box_size, inp_img_t.resolution, flag,                  $
                       Mag_diff_int,                                                    $
                       sep_abs,                                                         $
                       pa_abs,                                                          $
                       xc,                                                              $
                       yc,                                                              $
                       par.verbosity
                                ; non detection of main component, companion or both.
     if flag eq 0B then begin 
        init.Mag_diff_int[this_iter-1,*] = !values.f_nan ; difference of magnitude
        init.sep_all[this_iter-1]        = !values.f_nan ; absolute separation (detected)  
        init.pa_all[this_iter-1]         = !values.f_nan ; absolute PA (detected)  
        init.xc[*,this_iter-1]           = !values.f_nan ; X centroids (main and companion)  
        init.yc[*,this_iter-1]           = !values.f_nan ; Y centroids (main and companion)  
     endif else begin    
        init.Mag_diff_int[this_iter-1,*] = Mag_diff_int         
        init.sep_all[this_iter-1]        = sep_abs              
        init.pa_all[this_iter-1]         = pa_abs               
        init.xc[*,this_iter-1]           = xc                   
        init.yc[*,this_iter-1]           = yc                   
        if par.verbosity then begin
           print, ''
           print, 'Detected Primary   [x,y]           =', xc[0], yc[0]
           print, 'Detected Secondary [x,y]           =', xc[1], yc[1]
           print, 'Detected separation [mas]          =', sep_abs*1e3
           print, 'Detected position angle [deg]      =', pa_abs
           print, 'Detected difference of magnitude :'
           for i=0, (size(par.aper_phot))[1]-1 do begin
              print, '                     [diam '+string(par.aper_phot[i], '(f3.1)')+'] =', Mag_diff_int[i]
           endfor
           print, '================================================================================'
        endif
     endelse
     if (this_iter mod tot_iter EQ 0) then begin ;--- display line of results ---
        print, '-------------------------------------------------------------------'
        print, 'ANB:'
        print, ''								
        print, '================================================================================'
        print, '                       PHOTOMETRIC AND ASTROMETRIC BINARY ANALYSIS              '
        print, '================================================================================'
        print, ''								
        print, 'Centroid box size [pixels]                  = ', par.centr_box_size			
        print, 'Set of aperture diameters [pixels]          = ', par.aper_phot				
        print, ''
        print, 'Last iteration results :'
        print, 'Detected Primary   [x,y]                    =', xc[0], yc[0]
        print, 'Detected Secondary [x,y]                    =', xc[1], yc[1]
        print, ''
        print, 'Detected separation [mas]                   =', sep_abs*1e3
        print, 'Detected position angle [deg]               =', pa_abs
        print, ''
        print, 'Detected difference of magnitude :'
        for i=0, (size(par.aper_phot))[1]-1 do begin
           print, '                     [diam '+string(par.aper_phot[i], '(f3.1)')+'] =', Mag_diff_int[i]
        endfor
        print, '================================================================================'
        print, ''
                                ;binary data filename (.sav)
        sav_file = par.cvparam.filename
                                ;Save binary data
        result_bin	= {		 			        $
                          ap_phot_d            : par.aper_phot,        $
                          box_size             : par.centr_box_size,   $
                          Mag_diff_int         : init.Mag_diff_int,    $
                          sep_all              : init.sep_all,         $
                          pa_all               : init.pa_all,          $
                          xc                   : init.xc,              $
                          yc                   : init.yc,              $
                          d_detect             : par.d_detect,         $
                          tresh_detect         : par.tresh_detect,     $
                          pix_size             : inp_img_t.resolution  }
        save, result_bin, filename = sav_file  
                                ;Produce file .ps of parameters covergence ----------------------------
        enable   = [par.deltaM_cvplot.enable, par.separation_cvplot.enable, $
                    par.PA_cvplot.enable, par.Main_mag_cvplot.enable,       $
                    par.Comp_mag_cvplot.enable]              
        
        filename = [par.deltaM_cvplot.filename, par.separation_cvplot.filename, $
                    par.PA_cvplot.filename, par.Main_mag_cvplot.filename,       $
                    par.Comp_mag_cvplot.filename]              
                                ;first aperture phot. diam. to plot (0 begining)
        first = 0
                                ;pre_defined line type
        lsty         = [3,2,1,0,4,5,6]
        thickk       = [4,4,4,4,4,4,4]
        astr_lsty    = 0
        astr_tck     = 4
        make_graph_bin, sav_file, par.aper_phot, first, inp_img_t.resolution, $
                        lsty, thickk, astr_lsty, astr_tck, enable, filename   
     endif
  endelse
  return
end


