pro ap_phot_cent_comp_1it, res, star, nb_ph_star, sepT, paT, d_detect, tresh_detect, $
                           ap_phot_d, box_size, pix_size, flag,                      $
                           Mag_diff_int,                                             $
                           sep_rel,                                                  $
                           pa_rel,                                                   $
                           sep_abs,                                                  $
                           pa_abs,                                                   $
                           xc,                                                       $
                           yc,                                                       $
                           delta_M,                                                  $
                           verbosity
                           
  ap_phot_nb              = (size(ap_phot_d))[1]
  M 			= fltarr(2)
  delta_M 		= fltarr(2, ap_phot_nb)
  int 			= fltarr(2, ap_phot_nb)
  Mag_diff_int 	        = fltarr(ap_phot_nb)
  xc 			= fltarr(2)
  yc 			= fltarr(2)
  x_offset		= fltarr(2)
  y_offset		= fltarr(2)
;------------------------- Detection of each star maximum location ---------------------------
  star_d	= replicate({info:fltarr(3)},2)
  detect_binary_star, res, d_detect, tresh_detect, flag, out, verbosity ; Detect the binary star
; flag non-detect binary (main component, companion or both)
  if flag eq 0B then return 
  if verbosity then print, 'detect stars position [x1,y1,x2,y2] =', out[0].x, out[0].y, out[1].x, out[1].y
  star_d[0].info = [out[0].x, out[0].y, star[0].info[2]]
  star_d[1].info = [out[1].x, out[1].y, star[1].info[2]]
                                ;--- Aperture photometry and centroid calculations ---                        
                                ; Centroid calculation [xc,yc] 
  for i=0, 1 do begin
     tot = total(res[fix(star_d[i].info[0]) - fix(box_size/2):   $
                     fix(star_d[i].info[0]) + fix(box_size/2),   $
                     fix(star_d[i].info[1]) - fix(box_size/2):   $
                     fix(star_d[i].info[1]) + fix(box_size/2)]   )
     for x = (fix(star_d[i].info[0]) - fix(box_size/2)),        $
        (fix(star_d[i].info[0]) + fix(box_size/2)) do begin
        for y = (fix(star_d[i].info[1]) - fix(box_size/2)),    $
           (fix(star_d[i].info[1]) + fix(box_size/2)) do begin
           xc[i] = xc[i] + (x+0.5)*res[x,y]/ tot
           yc[i] = yc[i] + (y+0.5)*res[x,y]/ tot
        endfor
     endfor
     x_offset[i] = xc[i] - star[i].info[0]
     y_offset[i] = yc[i] - star[i].info[1]
  endfor
  sep_abs = (sqrt((xc[0]-xc[1])^2 + (yc[0]-yc[1])^2)) ;in pixel 
  if ((xc[1]-xc[0])/sep_abs) eq -1. then pa_abs = 180. $
                                ;remove the indetermination
                                ;of the following equation
  else pa_abs  = 2*atan (((yc[0]-yc[1])/sep_abs)/ 		$
                         (1 + (xc[1]-xc[0])/sep_abs))*180/!pi
  if pa_abs lt 0. then pa_abs = pa_abs + 360 ;enforce the positivity
                                ;of PA.
  pa_rel  = paT - pa_abs
  sep_rel = sepT - sep_abs * pix_size                                  ;in arcsec 
  sep_abs = (sqrt((xc[0]-xc[1])^2 + (yc[0]-yc[1])^2)) * pix_size       ;in arcsec
                                ;aperture photometry calculation ---  
                                ;photometry on the detected peak pixel
  for i=0, 1 do begin
     if (res[fix(star_d[i].info[0]), fix(star_d[i].info[1])] ne 0.)  then begin
        M[i]           = star[i].info[2]
        delta_M[i,0] = -2.5*alog10(nb_ph_star[i] /                                 $
                                   res[fix(star_d[i].info[0]),fix(star_d[i].info[1])])
     endif
  endfor
  Mag_diff_int[0] = (star[1].info[2] - star[0].info[2]) - 		$
                    2.5*alog10(res[fix(star_d[0].info[0]), fix(star_d[0].info[1])]/ 	$
                               res[fix(star_d[1].info[0]), fix(star_d[1].info[1])]) 
                                ;Aperture photometry around the centroid location
  for d=1, ap_phot_nb-1 do begin
     diam = ap_phot_d[d]
     for i=0, 1 do begin        
        tot = 0.
        for x = round(xc[i] - diam/2), round(xc[i] + diam/2) do begin
           for y = round(yc[i] - diam/2), round(yc[i] + diam/2) do begin
              if ((xc[i] - (x+0.5))^2 + (yc[i] - (y+0.5))^2 lt (diam^2/4)) then begin
                 tot = tot + res[x,y]
              endif
           endfor
        endfor
        int[i,d] = tot
        delta_M[i,d] = -2.5*alog10(nb_ph_star[i]/ tot)
     endfor
     Mag_diff_int[d] = (star[1].info[2] - star[0].info[2]) $ 
                       - 2.5*alog10(int[0,d]/int[1,d])
  endfor

return
end
