pro model_binary, x_main, y_main, x_comp, y_comp, sep, pa, mag, delt_m, nb_pix_in, eff, band, surf, $
                  int_time, pix_size, rap, binary, star, nb_ph_main, nb_ph_comp, verbosity



binary		= fltarr(rap*nb_pix_in, rap*nb_pix_in)
star	        = replicate({info:fltarr(3)},2)

;Main component ---------------------------------
xm = round(rap*x_main) 
ym = round(rap*y_main) 
star[0].info = [xm/rap, ym/rap, mag]


nb_ph         = eff*n_phot(mag, BAND=band, SURF=surf, DELTA_T=int_time)
nb_ph_main    = nb_ph[0]
binary[xm,ym] = nb_ph_main

;Second component -------------------------------
xc = round(rap*x_comp)
yc = round(rap*y_comp)
star[1].info = [xc/rap, yc/rap, mag+delt_m]

nb_ph         = eff*n_phot(mag+delt_m, BAND=band, SURF=surf, DELTA_T=int_time)
nb_ph_comp    = nb_ph[0]
binary[xc,yc] = nb_ph_comp

;Centered upsampled grid -> new separation and PA
sep_T = sqrt((xc-xm)^2 + (yc-ym)^2)

if ((xc-xm*rap)/sep_T) eq -1. then pa_T = 180. $		;remove the indetermination
								;of the following equation
 else pa_T = 2*atan (((ym-yc)/sep_T)/(1 + (xc-xm)/sep_T)) * 180/!pi

if pa_T lt 0. then pa_T = pa_T + 360.   			;enforce the positivity
								;of PA.

if verbosity then begin
   print, ''     
   print, 'Rounded pixel centering separation [arcsec] =', sep_T*pix_size/rap
   print, 'Rounded pixel centering Position Angle [deg.] =', pa_T
   print, ''     
endif

;update new values of separation and position angle
sep = sep_T*pix_size/rap
pa  = pa_T

return 
end
