; $Id: apply_filter.pro,v 1.1 2005/05/01 10.44 gabriele desidera' Exp $
;
;+
; NAME:
;    apply_filter.pro
;
; PURPOSE:
;    apply_filter performs a frequencies filter of an image 
;    
;
;
; CATEGORY:
;    FUNCTION
;
; CALLING SEQUENCE:
;    dummy = apply_filter(image, filter)
;
; INPUTS:
;    image     : image to be filtered
;    filter    : filter to apply to image
;
; OPTIONAL INPUTS:
;    none.
;
; KEYWORD PARAMETERS:
;    none.
;
; OUTPUTS:
;    filtered image whith a positivisation constrain
;
; OPTIONAL OUTPUTS:
;    none.
;
; COMMON BLOCKS:
;    none.
;
; SIDE EFFECTS:
;    none.
;
; RESTRICTIONS:
;    none.
;
; PROCEDURE:
;    none.
;
; EXAMPLE:
;    ...
;
; PROGRAM MODIFICATION HISTORY:
;    program written: May 2005,
;                     Gabriele Desidera' (DISI) [desidera@disi.unige.it].
;    modifications  : 
;
;
;-
;


function apply_filter, image, filter  


dim=size(image)
N=dim[1] & M=dim[2]

;help,image
fnt=shift(FFT(shift(image,N/2,M/2),-1,/double,/overwrite)*N*M,N/2,M/2)
fnt=fnt*filter
;help,fnt
fn=shift(fft(shift(fnt,N/2,M/2),1,/double,/overwrite)/(N*M),N/2,M/2)
;help,fn

b=double(fn[*,*]) > 0
bound=((total(b[*,0])+total(b[*,M-1])+total(b[0,*])+total(b[N-1,*]))/((N*2)+(M*2)))



A=double(fn)
pos=where(A le 0.,count)


if count gt 0 then begin
  for l=0., count-1 do begin
     xA=pos[l] mod N
     yA=pos[l] / N
     if ((xA gt 1) AND (yA gt 1) AND (xA lt N-2) AND (yA lt M-2)) then begin
       pos1=where(A[xA-2:xA+2,yA-2:yA+2] gt 0.,count1) 
       if count1 gt 0 then begin 
         A[xa,ya]=min(A[pos1])
       endif else begin
         A[xa,ya]=bound
       endelse
     endif else begin
       A[xa,ya]=bound
     endelse
  endfor
endif


return,A



end
