pro amas_phot_m, image, par, pt_0, mag_0, aper_diam,  $
                 result, BACK_RMS = back_rms  

;
; last modification: june 2003,
;                    Serge Correia (AIP) [scorreia@aip.de]:
;                   -fixed background value eliminated.
;                    Dec 2003, 
;                    S. Correia (AIP) :
;                   -use now MMM algorithm (through routine sky) to compute rms 
;                    sky for detection treshold. 
;                    If MMM algo fails, use the border of the frame to compute this value.   
; 
;

if (n_elements(back_rms) eq 0) then begin

        sky, image, back, back_rms, /silent
                                         ; Sky background evaluation using
                                         ; the Astrolib procedure SKY.

        ; test the validity of the sky value (non <0)
        if back lt 0. then back = 0.

        ; sometimes MMM algorithm fails in computing the background
        if ((back_rms le 0.) or (back_rms eq !VALUES.F_NAN)) then begin 
        back     = (moment(image[0:par.xest,0:par.yest]))[0]
        back_rms = sqrt((moment(image[0:par.xest,0:par.yest]))[1])
        endif

        print, 'estimated background [ph/pix]     =', back
        print, 'estimated RMS background          =', back_rms
endif

detect_l = back + par.sigma*back_rms ;detection treshold 

print, 'detection treshold at'+strcompress(par.sigma)+'sigma / pixel =', detect_l
if detect_l lt 0. then print, '========= WARNING -> detection treshold < 0 ======== '
if detect_l gt 0. then tresh_detect = detect_l else tresh_detect = 0.



astrolib_find_module, image, tresh_detect, par.fwhm_find,         $
                      par.roundlim_find, par.sharplim_find,       $
                      mag_0, pt_0, result,                        $
                      APER_DIAM=aper_diam                         
                      


return
end
