
pro astrolib_find_module, res, tresh_find, fwhm_find, roundlim_find, sharplim_find,  $
                          mag_0, pt_0, result, APER_DIAM=aper_diam 
if (n_elements(aper_diam)) lt 1      then aper_diam       = [3,6]

nb_pix_in = (size(res))[1]

astrolib_find, res, x, y, flux, sharp, round, tresh_find, fwhm_find,      $
               roundlim_find, sharplim_find, /silent, print=0

num_star = (size(flux))[1]
mag_aper = fltarr(num_star, (size(aper_diam))[1])

result	= replicate({					          $
                     fwhm_find            : fwhm_find,            $
                     tresh_find           : tresh_find,           $
                     roundlim_find        : roundlim_find,        $
                     sharplim_find        : sharplim_find,        $
		     xcenter              : 0.,                   $
                     ycenter              : 0.,                   $
                     flux                 : 0.,                   $
                     mag_find             : 0.,                   $
                     mag                  : fltarr((size(aper_diam))[1]),                   $
                     sharp                : 0.,                   $
                     round                : 0.                    }, num_star)

for d=0, (size(aper_diam))[1]-1 do begin
    for i=0, num_star-1 do begin
        tot = 0.
        for xx = round(x[i] - aper_diam[d]/2), round(x[i] + aper_diam[d]/2) do begin
            for yy = round(y[i] - aper_diam[d]/2), round(y[i] + aper_diam[d]/2) do begin 
                if ((xx-x[i])^2+(yy-y[i])^2 lt (aper_diam[d]^2/4)) then begin
                    if ((xx ge 0) and (yy ge 0) and (xx lt nb_pix_in) and (yy lt nb_pix_in))  $
                      then tot = tot + res[xx,yy]
                endif
            endfor
        endfor
        mag_aper[i,d]  = mag_0 - 2.5 * alog10(tot / pt_0)
        result[i].mag[d] = mag_aper[i,d]
    endfor
endfor

;aper, res, x, y, mags, errap, sky, skyerr, 1., aper_diam, [4.,8.], [-1e-7, 1e7], $
;      setskyval=0., /flux

if (size(aper_diam))[1] eq 1 then mag = 'Mag(d= '+string(aper_diam[0], '(I1)')+')'
if (size(aper_diam))[1] eq 2 then mag = 'Mag(d= '+string(aper_diam[0], '(I1)')+') ' + $
                                        'Mag(d= '+string(aper_diam[1], '(I1)')+')'
if (size(aper_diam))[1] eq 3 then mag = 'Mag(d= '+string(aper_diam[0], '(I1)')+') ' + $
                                        'Mag(d= '+string(aper_diam[1], '(I1)')+') ' + $
                                        'Mag(d= '+string(aper_diam[2], '(I1)')+')'

print, format = '(/1x,a)','      STAR    X       Y          FLUX     Mag_flux '+ mag

for i=0, num_star-1 do begin

    result[i].xcenter  = x[i]
    result[i].ycenter  = y[i]
    result[i].flux     = flux[i]
    result[i].mag_find = mag_0 - 2.5*alog10(flux[i] / pt_0)
    result[i].sharp    = sharp[i]
    result[i].round    = round[i]

if (size(aper_diam))[1] eq 1 then print, format='(5x, i5, 2f8.2, e12.2, 4x, 2f9.2)', $
       i+1, result[i].xcenter, result[i].ycenter, result[i].flux, result[i].mag_find, result[i].mag[0]
if (size(aper_diam))[1] eq 2 then print, format='(5x, i5, 2f8.2, e12.2, 4x, 3f9.2)', $
       i+1, result[i].xcenter, result[i].ycenter, result[i].flux, result[i].mag_find, result[i].mag[0], $
       result[i].mag[1] 
if (size(aper_diam))[1] eq 3 then print, format='(5x, i5, 2f8.2, e12.2, 4x, 4f9.2)', $
       i+1, result[i].xcenter, result[i].ycenter, result[i].flux, result[i].mag_find, result[i].mag[0], $
       result[i].mag[1], result[i].mag[2] 
endfor



return 
end

