function disk_ell, x0, y0, r_x, r_y, nb_pix

;Return a single-precision array (nb_pix x nb_pix) with a 
;elliptical disk centered in (x0,y0) and with radii (r_x, r_y). 
;Disk is normalised to unit energy.

disk_ell = fltarr(nb_pix,nb_pix)
for i=0, nb_pix-1 do begin
for j=0, nb_pix-1 do begin
        x=double(i) & y=double(j)
	if ((x0-x)^2.0/r_x^2.0 + (y0-y)^2.0/r_y^2.0) lt 1. then disk_ell[i,j] = 1.
	
endfor
endfor

disk_ell = disk_ell/total(disk_ell)
return, disk_ell
end
