function gauss_ell, x0, y0, sigm_x, sigm_y, nb_pix

;Return a double-precision array (nb_pix x nb_pix) with a 2D gaussian curve
;centered in (x0,y0) and with a HWHM egal at sigm. 
;The gaussian is also normalised at it integral value over the array.

gauss=dblarr(nb_pix,nb_pix)
for i=0, nb_pix-1 do begin
for j=0, nb_pix-1 do begin
        x=double(i) & y=double(j)
	gauss[i,j] = exp(-(((x-x0)^2.0/(2.0*sigm_x^2.0))+((y-y0)^2.0/(2.0*sigm_y^2.0))))
	
	
endfor
endfor

gauss=gauss/total(gauss)
return, gauss
end
