pro model_extended_obj_mag_tot, obj_filename, pix_size, nb_pix_in, dim_obj, mag_tot, $
                               band, object, nb_ph_object 

;------------------------------ Read the object model .fits processed file -------------

obj = readfits(obj_filename, /silent)

dim = size(obj)
nb_pix_ob = dim[1]

;-------------------- Scale the object in the field ------------------------------------

dim_im = fix((pix_size * nb_pix_in / dim_obj) * nb_pix_ob)
						; in pixels in the original array

if dim_im le nb_pix_ob then begin

      temp	= obj[nb_pix_ob/2-dim_im/2:nb_pix_ob/2+dim_im/2-1,      $
                      nb_pix_ob/2-dim_im/2:nb_pix_ob/2+dim_im/2-1]
endif else begin

                    temp = fltarr(dim_im, dim_im)
                    temp[dim_im/2-nb_pix_ob/2:dim_im/2+nb_pix_ob/2-1, $
                         dim_im/2-nb_pix_ob/2:dim_im/2+nb_pix_ob/2-1] = obj
endelse
object = congrid (temp, nb_pix_in, nb_pix_in,/INTERP)


; put negative pixel values to zero
if (min(object) lt 0.) then object = object + abs(min(object))


;-------------------- Put the energy in the model -------------------------------------

field_extension  = pix_size * nb_pix_in                     ; in arcsec 

nb_ph_object  = (n_phot(mag_tot, BAND=band))[0] 

print, 'Object filename                = ', obj_filename
print, 'Pixel size [arcsec]            = ', pix_size
print, 'Array dimensions [pixels]      = ', nb_pix_in
print, 'Total field extension [arcsec] = ', field_extension
print, 'Object dimensions [arcsec]     = ', dim_obj
print, 'Total object magnitude         = ', mag_tot
print, 'Total object flux [ph/s/m2]    = ', nb_ph_object

object = object/total(object) * nb_ph_object


return
end

