pro model_random_clust, nb_star, mag_max, mag_min, seed, nb_pix_in,  $
                        band, pix_size, clust, nb_phot_clust

clust         = fltarr(nb_pix_in,nb_pix_in)
nb_phot_clust = 0D

for i=0, nb_star/2-1 do begin

	             x = (nb_pix_in-1)*randomn(seed,/uniform)
	             y = (nb_pix_in-1)*randomn(seed,/uniform)
	           mag = mag_min+(mag_max-mag_min)*(randomn(seed,/uniform))
         nb_ph_star    = (n_phot(mag, BAND=band))[0]
         nb_phot_clust = nb_phot_clust + nb_ph_star

	clust[round(x),round(y)] = nb_ph_star
endfor

for i=nb_star/2, nb_star-1 do begin

	             x = (nb_pix_in/2+nb_pix_in/7*randomn(seed,/normal))
	             y = (nb_pix_in/2+nb_pix_in/7*randomn(seed,/normal))
	           mag = mag_min+(mag_max-mag_min)*(randomn(seed,/uniform))
         nb_ph_star    = (n_phot(mag, BAND=band))[0]
         nb_phot_clust = nb_phot_clust + nb_ph_star

	clust[round(x),round(y)] = nb_ph_star
endfor

field_extension  = pix_size * nb_pix_in                 ; in arcsec

print, 'Randomn generated open cluster :'
print, ''	
print, 'Star number                                   =', nb_star							
print, 'Minimum magnitude                             =', mag_min
print, 'Maximum magnitude                             =', mag_max
print, 'Generation seed                               =', seed
print, 'Pixel size [arcsec]                           =', pix_size
print, 'Array dimensions [pixels]                     =', nb_pix_in
print, 'Total field extension [arcsec]                =', field_extension
print, 'Total object flux [ph/s/m2]                   =', nb_phot_clust
print, ''								

return
end
