function model_single_star, x_pos, y_pos, mag, nb_pix_in, band, pix_size,  $
                            single, nb_ph_object

error = !caos_error.ok

single = fltarr(nb_pix_in, nb_pix_in)

nb_ph = (n_phot(mag, BAND=band))[0]
single[x_pos,y_pos] = nb_ph

field_extension  = pix_size * nb_pix_in        ; in arcsec
nb_ph_object = nb_ph


; print object characteristics

print, ''
print, ''
print, 'Single star :'
print, ''
print, 'Star magnitude                 =', mag
print, 'Pixel size [arcsec]            =', pix_size
print, 'Array dimensions [pixels]      =', nb_pix_in
print, 'Total field extension [arcsec] =', field_extension
print, 'Total object flux [ph/s/m2]    =', nb_ph_object
print, ''     


return, error
end
