pro model_stellar_surf, star_mag, star_diam, ax_ratio, spot_diam, spot_flux,   $
                        spot_dist, spot_pa, pix_size, nb_pix_in, band, star,   $
                        nb_ph_star 


star		= fltarr(nb_pix_in,nb_pix_in)
gauss		= fltarr(nb_pix_in,nb_pix_in)

star = disk_ell(nb_pix_in/2, nb_pix_in/2, star_diam/(2.0*pix_size*1e3), $
                        ax_ratio*star_diam/(2.0*pix_size*1e3),nb_pix_in)

mask=make_array(nb_pix_in,nb_pix_in)
pos=where(star ne 0.0)
mask(pos)=1.0

convolution, star, gauss_ell(nb_pix_in/2, nb_pix_in/2, 1, 1, nb_pix_in), star, nb_pix_in


star = star/total(star)

nb_ph_star    = (n_phot(star_mag, BAND=band))[0]

star = (100.-spot_flux)/100.* nb_ph_star * star

x = fix(nb_pix_in/2 + spot_dist/(pix_size*1e3)*cos(spot_pa*!pi/180))
y = fix(nb_pix_in/2 - spot_dist/(pix_size*1e3)*sin(spot_pa*!pi/180))


star =  star + (spot_flux/100.* gauss_ell(x, y, spot_diam/(2*pix_size*1e3), spot_diam/(2*pix_size*1e3),nb_pix_in) $
          * nb_ph_star)*mask

print, ''
print, 'Stellar surface:'
print, ''
print, 'Star magnitude                                =', star_mag 
print, 'Star diameter [mas]                           =', star_diam
print, 'Star axial ratio                              =', ax_ratio
print, 'Spot diameter [mas]                           =', spot_diam
print, 'Spot flux [% of the total flux]               =', spot_flux
print, 'Spot location (radius from center) [mas]      =', spot_dist
print, 'Spot position angle [deg.]                    =', spot_pa 
print, ''


return
end
