; $Id: pex_img_options.pro, v 7.1 last revision 2017/01/09 Andrea La Camera $
;+
; pex_img_options is used to manage VISUALIZATION OPTIONS (opened when a right-click
; is done on the widget areas).


pro pex_img_options_settings
common img_options, param, id
if param.scale LT 2 then widget_control, id.power, SENSITIVE=0 $
else widget_control, id.power, /SENSITIVE
end

pro pex_img_options_event, event

common img_options, param, id

WIDGET_CONTROL, event.id, GET_UVALUE=uvalue
WIDGET_CONTROL, event.top, GET_UVALUE=id
case uvalue of
'zoom': param.zoom=event.value
'z1': begin
      param.zoom=0.25
      widget_control, id.zoom, set_value=param.zoom
      end
'z2': begin
      param.zoom=0.5
      widget_control, id.zoom, set_value=param.zoom
      end
'z3': begin
      param.zoom=1.
      widget_control, id.zoom, set_value=param.zoom
      end
'z4': begin
      param.zoom=2.
      widget_control, id.zoom, set_value=param.zoom
      end
'z5': begin
      param.zoom=4.
      widget_control, id.zoom, set_value=param.zoom
      end
'scale':begin
    param.scale=event.index
    pex_img_options_settings
    end 
'power':param.power=event.value 
'color':param.color=event.index
'ok'   : begin
         WIDGET_CONTROL, event.top, /DESTROY
         end
endcase
;
end


;;;;;;;;;;;;;;;;;;;;;;;;;
; GUI generation code
;;;;;;;;;;;;;;;;;;;;;;;;;
function pex_img_options, title, state, GROUP_LEADER=group, psf=psf

common img_options, param, id

param=state.par

;param is the structure (of the parameters) containing edited/modified values
;orig is the structure containing original values

id = { root_base_id0: 0L, scale:0L, power:0L, color:0L, zoom:0L}

;modal = n_elements(group) ne 0
root_base_id0 = widget_base(TITLE=title,/COL, /modal, GROUP_LEADER=group)
base = widget_base(root_base_id0, /FRAME,/COL)

if keyword_set(psf) then begin
    id.zoom=CW_FIELD(base, title="Zoom [ENTER]: ", value=param.zoom, $
                    /FLOATING, uvalue="zoom", $
                     /RETURN_EVENTS, xsize=10 ) 
    base1 =widget_base(base, /ROW)
    button1=WIDGET_BUTTON(base1, value='0.25 x', xsize=50, uvalue="z1")
    button2=WIDGET_BUTTON(base1, value='0.5 x ', xsize=50, uvalue="z2")
    button3=WIDGET_BUTTON(base1, value='  1 x ', xsize=50, uvalue="z3")
    button4=WIDGET_BUTTON(base1, value='  2 x ', xsize=50, uvalue="z4")
    button5=WIDGET_BUTTON(base1, value='  4 x ', xsize=50, uvalue="z5")
endif

scale_str=['Linear', 'Log10(1+map)', 'Power']
label=WIDGET_LABEL(base, value="Scale : ")
id.scale=WIDGET_COMBOBOX(base, value=scale_str, uvalue='scale')

id.power= CW_FIELD(base, title="Display the map at the power of [ENTER]: ", value=param.power, $
                    /FLOATING, uvalue='power', $
                     /RETURN_EVENTS, xsize=5 ) 
loadct, GET_NAMES=color_str, /SILENT
label=WIDGET_LABEL(base, value="Color : ")
id.color=WIDGET_COMBOBOX(base, value=color_str, uvalue='color')


; standard buttons base
btn_base_id = widget_base(root_base_id0,/FRAME,/ROW, /ALIGN_RIGHT)
ok_id = widget_button(btn_base_id,  VALUE=" Apply and close ", UVALUE="ok")



WIDGET_CONTROL, root_base_id0, SET_UVALUE=id
WIDGET_CONTROL, root_base_id0, /REALIZE
WIDGET_CONTROL, id.scale, set_combobox_select=param.scale
WIDGET_CONTROL, id.color, set_combobox_select=param.color
pex_img_options_settings
xmanager, 'pex_img_options', root_base_id0, /NO_BLOCK, GROUP_LEADER=group
return, param
end
