;modified 2016-07-20 ALC: added optional input CENTER (must be an
;array with coordinates [x0,y0] )

function pex_circular_mask, dim, radius, type, CENTER=cen
; dim is the dimension of the mask
; radius is the size of the circle
; 'in': 1 into inner region
; 'out' 1 into outer region
; cen = [x0,y0]

if keyword_set(cen) then begin
   x0 = cen[0]
   y0 = cen[1]
endif else begin
   x0=dim/2
   y0=dim/2
endelse

dim=double(dim)
radius=double(radius)

x=(dindgen(dim)) # (dblarr(dim)+1)
y=(dblarr(dim)+1) # (dindgen(dim))
r2=(x-x0)^2+(y-y0)^2
index=where(r2 LE radius^2, count, complement=c_index)
circ = make_array(dim,dim,value=0.)

if count EQ 0 then return, circ 
if type EQ 'in' then circ[index]=1. 
if type EQ 'out' then circ[c_index]=1.
return, circ

;case type of
;   'in' : begin
;   circ = make_array(dim,dim,value=0.)
;   for xx=0,dim-1 do begin
;      for yy=0,dim-1 do begin
;         if (xx-dim/2)^2.+(yy-dim/2)^2. LE radius^2. then circ[xx,yy]=1.
;      endfor
;   endfor
;   return, circ
;   end
;
;   'out' : begin
;   circ = make_array(dim,dim,value=1.)
;   for xx=0,dim-1 do begin
;      for yy=0,dim-1 do begin
;         if (xx-dim/2)^2.+(yy-dim/2)^2. LE radius^2. then circ[xx,yy]=0.
;      endfor
;   endfor
;   return, circ
;   end
;endcase
end
