	
pro phot_rec, in, line, tresh, out

;tresh     = 5
;line      = 3

print, 'treshold computation = ', tresh, ' sigma' 
print, 'sigma estimated in the x-band ', 0, line-1 
print, ''

dim       = size(in)

; 3-dimensions data cube case
if dim[0] eq 3 then begin
    nb_pix    = dim[1]
    nb_angl   = dim[3]
    out       = fltarr(nb_pix, nb_pix, nb_angl)

    ; found the photocenter of the first frame
    temp = in[*,*,0] 
    dummy = photcenter (temp, TRESH=tresh, LINE=line) 
    ph_cent_x_ref = dummy[0] 
    ph_cent_y_ref = dummy[1] 
    out[*,*,0] = in[*,*,0]
    print, 'photocenter reference [x,y] =', ph_cent_x_ref, ph_cent_y_ref
    print, ''

    ; centering of the other frames wrt the photocenter of the 1st frame
    for k=1, nb_angl-1 do begin

        dumb = in[*,*,k]
        phot_rec_mod, dumb, nb_pix, tresh, line, ph_cent_x_ref, ph_cent_y_ref, temp
        out[*,*,k] = temp

    endfor

endif



return
end

