pro phot_rec_mod, in, nb_pix, tresh, line, ph_cent_x_ref, ph_cent_y_ref, out

out       = fltarr(nb_pix, nb_pix)

; found the photocenter of the frame
dummy = photcenter(in, TRESH=tresh, LINE=line)
ph_cent_x = dummy[0]
ph_cent_y = dummy[1]

; perform the frame shift 
out = fftshift(in, ph_cent_x_ref-ph_cent_x, ph_cent_y_ref-ph_cent_y)

print, 'photocenter frame                       [x,y] =', ph_cent_x, ph_cent_y
print, 'photcenter frame - photcenter reference [x,y] =', ph_cent_x-ph_cent_x_ref, ph_cent_y-ph_cent_y_ref
print, 'shift applied to the frame              [x,y] =', ph_cent_x_ref-ph_cent_x, ph_cent_y_ref-ph_cent_y
print, ''



return
end
