;pre_find_boundary
;
;INPUTS
;    input_img:  is the input image (typically a mask of ones and zeroes of the
;                image)
;    width:      is the dimension of the wanted boundary
;
;OUTPUT
;    output_img: is the output image that contains only the wanted boundary 
;
; MODIFICATIONS:  
;    previous name: find_boudary 
;    new name: pre_find_boundary (for compatibility reasons)
;last modified: march 2013 (Andrea La Camera)

function pre_find_boundary, input_img, width

on_error,2
N=(size(input_img))[1]
M=(size(input_img))[2]

array=where(input_img NE 0., count)
if count GT 0 then begin
dummy=make_array(N,M)
dummy[array]=1.

dummyL=shift(dummy,width,0)
dummyL[0:width-1,*]=0.
dummyL=(dummy-dummyL)>0

dummyR=shift(dummy,-width,0)
dummyR[N-width:N-1,*]=0.
dummyR=(dummy-dummyR)>0

dummyD=shift(dummy,0,width)
dummyD[*,0:width-1]=0.
dummyD=(dummy-dummyD)>0

dummyT=shift(dummy,0,-width)
dummyT[*,M-width:M-1]=0.
dummyT=(dummy-dummyT)>0

output_img=dummyL OR dummyR OR dummyD OR dummyT

; window, xsize=N, ysize=M
; tvscl, output_img

endif else output_img = input_img
return, output_img

end
