pro memory_test_calculate, state

COMMON zero_padding, zp

   dummy=((double(state.param.n)*double(zp))^2.)*8.*3.
   dummy = dummy / (1024.*1024.)
   if dummy GT 1024. then begin
		dummy = dummy / 1024. 
		label = strtrim(dummy,1)+' GB'
   endif else begin
	    label = strtrim(ceil(dummy),1)+' MB'
   endelse
   widget_control, state.id.mem, set_value=label
end
;-----------------------------------------------------------

pro memory_test_gui_event, event

COMMON zero_padding, zp

widget_control, event.id, GET_UVALUE=uvalue
widget_control, event.top, get_uvalue=state
case uvalue of 
	'zp': 	begin
			if event.value LE 1 then begin
			dummy=dialog_message(['Zero-padding factor MUST be',$
			'an integer number greater than 1'],$
			title='RTI Warning')
			endif	
			zp=event.value
			end

	'size': begin
			dummy=event.value
			state.param.n=fix(dummy)
			end
	'done': begin
			widget_control, event.top, /destroy
			return
			end
endcase
memory_test_calculate, state
widget_control, event.top, SET_UVALUE=state
return
end

;-----------------------------------------------------------

function memory_test_gui, zero_padding, n, GROUP_LEADER=group

COMMON zero_padding, zp

zp=zero_padding

error=!caos_error.ok

id = {mem:0L}
param = {n:n, mem:''}
state = {id:id, param:param}

title='RTI - Memory_test_GUI'
modal = n_elements(group) ne 0
root_base_id0 = widget_base(TITLE=title,/COL,MODAL=modal, GROUP_LEADER=group)
root_base_id = widget_base(root_base_id0,/COL)
   dummy = CW_FIELD(root_base_id, value=zp, uvalue='zp', $
                    title='Zero-padding factor: [ENTER]',/return_event,/int)
   dummy = CW_FIELD(root_base_id, value=state.param.n, uvalue='size',$
					title='Image dimension (greatest value): [ENTER]',/return_event)
   dummy = WIDGET_LABEL(root_base_id, value='   ')
   dummy = WIDGET_LABEL(root_base_id, value='Memory Required:')
   state.id.mem = WIDGET_TEXT(root_base_id, value=state.param.mem)
   base_button = widget_base(root_base_id,/align_center)
	   dummy=WIDGET_LABEL(base_button, value='   ')
       dummy=widget_button(base_button,value='done!', uvalue='done')

memory_test_calculate,state
WIDGET_CONTROL, root_base_id0, SET_UVALUE=state
widget_control, root_base_id0, /REALIZE

xmanager, 'memory_test_gui', root_base_id0, GROUP_LEADER=group
return, error
end
