pro update_keywordlist, verbose = verbose

if keyword_set(verbose) then verb=1 else verb=0
debug = 0
pack_name = 'AIRY_Software_Package_7.0'
path = !caos_env.modules+pack_name+'/modules'
spawn, 'ls '+path , modules
if verb then print, 'MODULES = ', modules

output = !caos_env.modules+pack_name+'/FitsHeader_Keywords_definition.txt'
if verb then print, output
if file_test(output,/regular) then begin
   spawn, 'mv '+output+' '+output+'.old'
   print, 'Backup of the previous file -- done!'
endif
openw, 22, output
printf,22,'Module Keywords Description '
printf,22,'---    -------- ----------------------------------------------------------------'
for k=0,n_elements(modules)-1 do begin
   file = path+'/'+modules[k]+'/'+modules[k]+'_init.pro'
   if modules[k] EQ 'cbd' then file = path+'/'+modules[k]+'/'+modules[k]+'_prog.pro'
   if modules[k] EQ 'dec' then file = path+'/'+modules[k]+'/'+modules[k]+'_prog.pro'
   if modules[k] EQ 'mcd' then file = path+'/'+modules[k]+'/'+modules[k]+'_prog.pro'
   
   if verb then print, 'FILE = ', file
   openr,11,file
   l=''
   while ~EOF(11) do begin 
      ok = 1
      readf,11,l 
      if strmatch(l,'*fxaddpar*') then begin
         if debug then print, l
         a = STRUPCASE(modules[k])+'    '
         if strmatch(l, '*for*') then begin
            pos = strpos(l,'fxaddpar')
            l = strmid(l, pos, strlen(l)-pos)
         endif
         if strmatch(l, '*if*') then begin
            pos = strpos(l,'fxaddpar')
            l = strmid(l, pos, strlen(l)-pos)
         endif
         if ~strmatch(l, "*'*") then ok = 0 else begin
            b= string((strsplit((strsplit(l,',',/extract))[2],"'",/extract))[1],FORMAT='(A8)')
            c=(strsplit(strcompress(l),',',/extract, count=NC))[NC-1]
         endelse
         if ok AND verb then print,'   ', a,b,c
         if ok then printf,22,a,b,c
      endif
   endwhile
   close,11

endfor
printf,22,'---    -------- ----------------------------------------------------------------'
printf,22,''
printf,22,'Automatically generated by update_keywordlist.pro'
printf,22,'Last update: '+systime(0)
close,22


end

